---
title: New in Version 0.13.685
shorttitle: Version 0.13.685
number: 0.13.685
date: 2016-06-15 
---

### Simple Interface Changes

* New abstract interfaces for I/O (classes ```input``` and ```output```)
  for all library I/O (except for internal debugging I/O).
  Use classes ```FILE_input``` and ```FILE_output``` for C-style
  ```FILE*``` I/O,
  and classes ```istream_input``` and ```ostream_output```
  for C++-style ```iostream``` I/O.
  ```meddly.h``` now includes both ```cstdio``` and ```iostream```.
  These can be disabled if necessary 
  by defining ```_MEDDLY_WITHOUT_CSTDIO_```
  or ```_MEDDLY_WITHOUT_IOSTREAM_```, respectively,
  before including ```meddly.h```.


### Expert Interface Changes

* Class ```node_reader``` is now class ```unpacked_node```,
    and methods to initialize a node reader have been moved into
    the ```unpacked_node``` class.
* Class ```node_builder``` has been eliminated;
    all functionality has been moved to class ```unpacked_node```.
* Class ```node_header``` is now a private inner class
    for class ```expert_forest```;
    all access to node header information 
    should be through getter and setter helper functions.
* Prototype implementation of saturation on partitioned transition relations.
    See operation ```SATURATION_FORWARD``` and class
    ```satpregen_opname```.
* Prototype implementation of on-the-fly saturation.
    See operation ```SATURATION_OTF_FORWARD``` and class
    ```satotf_opname```.


### Implementation Changes

* Fixed several bugs with node reference counts.

