---
title: New in Version 0.14.818
shorttitle: Version 0.14.818
number: 0.14.818
date: 2017-07-05 
---

### Simple Interface Changes

* Class ```node_storage``` factory portion split into
      new class, ```node_storage_style```.
      Interface updated.
* Forest policies must be constructed after library initialization,
      because node storage styles will not be known before this.
      A new empty constructor, and method ```useDefaults```, have
      been added to class ```forest::policies``` to allow this.
* Changed error code ```OVERFLOW``` to ```VALUE_OVERFLOW```
      to avoid name issues with math macro.

### Expert Interface Changes

* Default policies for MDD and MXD forests moved from
      class ```settings``` to class ```forest``` as static members.  This
      allows the defaults to be changed after library initialization.
* Initialization sequence has been removed from class ```settings```,
      and is instead passed to the MEDDLY initialization function explicitly.
* Class ```op_initializer``` has been converted into
      a generic library initialization class, ```initializer_list```.
* Class ```cleanup_procedure``` has been removed;
      use ```initializer_list``` instead.
* Compute table initialization is now handled by an initializer,
  class ```ct_initializer```.  The compute table settings have been moved
  from class ```settings```, and into this new class.  To change the
  default compute table settings, you should
    1.  Build and save the default initializer list, 
        using ```defaultInitializerList()```.
    2.  Change the compute table settings, using static methods of class
        ```ct_initializer```.
    3.  Initialize the library, using the initializer list that was saved
        in step 1.
* The old class ```settings``` has been removed, since it has become empty.


### Implementation Changes

* Node storage styles are now set up using an ```initializer_list```.


