---
title: New in Version 0.5.186
shorttitle: Version 0.5.186
number: 0.5.186
date: 2011-06-16
---

### New Features

* Variables in domains are represented by
  instances of class  ```variable```, instead of integers.
  The same variable may appear in more than one domain.

* Domain levels are always in the order: topmost, ..., 2, 1, 0
  where level 0 is for terminal nodes.
  As such, level mapping is no longer necessary.

* For convenience, there is a new function
  ```c++
  MEDDLY::createDomainBottomUp(...)
  ```
  which combines domain creation and variable initialization.

* There are new functions to destroy objects,
  ```c++
  MEDDLY::destroyDomain(...)
  MEDDLY::destroyForest(...)
  ```
  and these must be used instead of  ```delete```.


### Deprecated Functions

| Now deprecated | Equivalent replacement |
|:--------------:|:----------------------:|
|```domain::getTopVariable()```|```domain::getNumVariables()```|
|```domain::getVariableAbove(v)```|```v+1```|
|```domain::getVariableBelow(v)```|```v-1```|
|```expert_domain::getVariableHeight(v)```| ```v```|
|```expert_domain::getVariableWithHeight(h)```| ```h```|


### Known Issues 

* Calling  ```MEDDLY::cleanup()``` can sometimes cause 
  a segmentation fault.
  Destroying all domains before calling  ```cleanup()``` seems to fix this.

