---
title: New in Version 0.9.397
shorttitle: Version 0.9.397
number: 0.9.397
date: 2012-07-26
---

* New unique table.
* New iterator implementation for ```dd_edge``` class.
* Using fine-grained identity reduction rules.
* Lots of code reorganization and cleanup.

### Simple Interface Changes

* Iterators have been replaced with enumerators.
  The old code segment
  ```c++
  for (dd_edge::const_iterator i = e.begin(); i; ++i) 
  ```
  should be replaced by
  ```c++
  for (enumerator i(e); i; ++i) 
  ```
  and most other ```iterator``` functionality has been included 
  in the ```enumerator``` class.

* Removed ```findFirstElement``` methods,
  the same behavior can be obtained with enumerators.

* Removed ```createSubmatrix``` methods,
  the same behavior can be obtained with the cross product
  and intersection operators.


### Expert Interface Changes

* Added ```node_builder``` subclass, updated operations to use it.
  This is the mechanism to use for building new nodes.

* Added ```node_reader``` subclass, updated operations to use it.
  This is the mechanism to use for reading nodes in a forest.

* Removed most of the old interface for accessing nodes.

* Removed temporary edges.

